
--[[
Name: HzFontPack1
Author: Hizuro (Der Mithrilorden|EU)
]]

local addon, ns = ...

local f = CreateFrame("frame")

f.locale = GetLocale()
f.sol = LibStub("LibSimpleOptions-1.0")
f.sml = LibStub("LibSharedMedia-3.0")
f.filepath = "Interface\\Addons\\"..addon.."\\fonts\\"
f.fonts = {
	["7days"]							= "7days.ttf",
	["Agency FB"]					= "Agency_FB.ttf",
	["Alcohole"]					= "Alcohole.ttf",
	["Antartic"]					= "ANTARG__.TTF",
	["Architext"]					= "architxt.ttf",
	["AtomicSushi"]				= "AtomicSushi.ttf",
	["Avocado"]						= "avocado_.ttf",
	["BTSE + PS2"]				= "btseps2.TTF",
	["Brush Script MT"]		= "BRUSHSCI.TTF",
	["Californian"]				= "CALIFR.TTF",
	["Chiller"]						= "CHILLER.TTF",
	["Comic Script Shaded"]	= "SF Comic Script Shaded.ttf",
	["Comic Script"]				= "SF Comic Script.ttf",
	["CreepyGirl"]					= "CREERG__.TTF",
	["Dali"]								= "dali____.ttf",
	["Dark Horse"]					= "Darkh4.ttf",
	["DragonFly"]						= "dragonfly.ttf",
	["Dreamerone"]					= "dfdrone.ttf",
	["Facelift"]						= "facerg__.ttf",
	["Fette Fraktur"]				= "ff______.ttf",
	["Gizmo"]								= "gizmo___.ttf",
	["Gushing meadow"]			= "sf gushing meadow.ttf",
	["Headhunter regular"]	= "he______.ttf",
	["Japan"]								= "japan.ttf",
	["Klingondagger"]				= "klingondagger.ttf",
	["Liquidcrystal"]				= "liquidn.ttf",
	["Loki cola"]						= "lokicola.ttf",
	["Lucida Console"]			= "lucon.ttf",
	["Lucida Sans"]					= "lsans.ttf",
	["Neurochrome"]					= "neurochr.ttf",
	["New brilliant"]				= "newbrill.ttf",
	["Old english text"]		= "oldengl.ttf",
	["Telegraphic"]					= "sf telegraphic.ttf",
	["Typographerfraktur"]	= "typographerfraktur-medium.ttf",
	["Visitor1"]						= "visitor1.ttf",
	["Visitor2"]						= "visitor2.ttf",
}

f.lang = {
	["enUS"] = {
		["description"]		= "Thank you for choosing this fontpacks\n\nThis frame provide the option to disable fonts from this pack.\n",
		["toggleTT"]	= "Enable/Disable %s",
		["btSelAll"]			= "Select all",
		["btSelNone"]			= "Select none",
		["btReload"]			= "Reload UI",
		["btSelAllTT"]			= "-",
		["btSelNoneTT"]			= "-",
		["btReloadTT"]			= "-",
	},
	["deDE"] = {
		["description"] = "Danke, dass Sie sich für dieses Paket an Zeichensätzen entschieden haben.\nDieses Fenster bietet Ihnen die Möglichkeit Zeichensätze dieses Pakets zu deaktivieren.\n\n|cffff4444Veränderungen werden erst durch Neuladen des Benutzeroberfläche wirksam! ( /reload )|r",
		["toggleTooltip"] = "Aktiviere/Deaktiviere %s",
--		["btSelAll"]			= "",
--		["btSelNone"]			= "",
--		["btReload"]			= "",
--		["btSelAllTT"]			= "",
--		["btSelNoneTT"]			= "",
--		["btReloadTT"]			= "",
	},
--	["esES"] = "",
--	["esMX"] = "",
--	["frFR"] = "",
--	["itIT"] = "",
--	["koKR"] = "",
--	["ptBR"] = "",
--	["ruRU"] = "",
--	["zhCN"] = "",
--	["zhTW"] = ""
}

function f:RegisterFonts()
	for fontName, fontFile in pairs(f.fonts) do
		if type(fontName) == "string" and fontName ~= "" and type(fontFile) == "string" and fontFile ~= "" and HzFontPack1DB[fontName] ~= false then
			f.sml:Register("font", fontName, f.filepath..fontFile, 255)
		end
	end
end

function f:Options(self, anchor)
	local title, subText = self:MakeTitleTextAndSubText(addon,f.lang[f.locale].description or f.lang.enUS.description)

	f.panel.sframe = self:MakeScrollFrame()
	f.panel.sframe:SetPoint("TOPLEFT",subText,"TOPLEFT",10,-55)
	f.panel.sframe:SetWidth(550)
	f.panel.sframe:SetHeight(390)

	f.panel.sframe.child = CreateFrame("Frame",addon.."_ScrollFrameChild",f.panel.sframe)
	f.panel.sframe.child:SetWidth(1)
	f.panel.sframe.child:SetHeight(1)
	f.panel.sframe:SetScrollChild(f.panel.sframe.child)

	f.panel.sframe.child.controls = {}
	for k, v in pairs(f.sol.panelMeta) do
		f.panel.sframe.child[k] = v
	end

	local entry = {}
	local last = 10
	local count = 0
	local row = "odd"
	for fontName, fontFile in pairs(f.fonts) do

		entry[count] = f.panel.sframe.child:MakeToggle(
			'name', fontName,
			'description', string.format(f.lang[f.locale].toggleTT or f.lang.enUS.toggleTT,fontName),
			'default', true,
			'getFunc', function() return HzFontPack1DB[fontName] ~= false end,
			'setFunc', function(value) HzFontPack1DB[fontName] = value end
		)
		entry[count]:SetPoint("TOPLEFT", entry[count-1] or f.panel.sframe.child, "BOTTOMLEFT", count~=0 and 0 or 10, -6)

		if row == "odd" then
			row = "even"
		else
--			local bg = CreateFrame("Frame",nil,entry[count])
--			bg:SetPoint("TOPLEFT",entry[count],"TOPLEFT",-2,2)
--			bg:SetPoint("BOTTOMRIGHT",entry[count],"BOTTOMRIGHT",510,-2)
--			bg:SetBackdrop({bgFile = [=[Interface\Buttons\WHITE8X8]=],tile = true,tileSize = 16})
--			bg:SetBackdropColor(1,1,1,0.15)
--			bg:SetFrameLevel(entry[count]:GetFrameLevel() - 2)
			row = "odd"
		end

		entry[count].example = entry[count]:CreateFontString(nil,"ARTWORK")
		entry[count].example:SetFont(f.filepath..fontFile,15)
		entry[count].example:SetText("a b c A B C 0 1 2 3")
		entry[count].example:SetJustifyV("CENTER")
		entry[count].example:SetPoint("TOPLEFT",entry[count],"TOPLEFT",200,-7)

		count = count + 1
	end

	local footSpacer = CreateFrame("Frame",nil,entry[count-1])
	footSpacer:SetWidth(1)
	footSpacer:SetHeight(6)
	footSpacer:SetPoint("TOPLEFT",entry[count-1], "BOTTOMLEFT",0,-6)

	local btSelAll = self:MakeButton(
		'name', f.lang[f.locale].btSelAll or f.lang.enUS.btSelAll,
		'description', '',
		'func', function()
			for fontName, Value in pairs(HzFontPack1DB) do
				HzFontPack1DB[fontName] = true
			end
			f.panel.sframe.child:Refresh()
		end
	)
	local btSelNone = self:MakeButton(
		'name', f.lang[f.locale].btSelNone or f.lang.enUS.btSelNone,
		'description', '',
		'func', function()
			for fontName, Value in pairs(HzFontPack1DB) do
				HzFontPack1DB[fontName] = false
			end
			f.panel.sframe.child:Refresh()
		end
	)
	local btReload = self:MakeButton(
		'name', f.lang[f.locale].btReload or f.lang.enUS.btReload,
		'description', '',
		'func', function() ReloadUI() end
	)

	btSelAll:SetPoint("TOPLEFT",f.panel.sframe,"BOTTOMLEFT",0,-10)
	btSelNone:SetPoint("TOPLEFT",btSelAll,"TOPRIGHT",10,0)
	btReload:SetPoint("TOPRIGHT",f.panel.sframe,"BOTTOMRIGHT",0,-10)

	local footer = f.panel:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall")
	footer:SetText("|cff00aaffAuthor: Hizuro (Der Mithrilorden|EU)|r")
	footer:SetJustifyH("CENTER")
	footer:SetPoint("BOTTOMRIGHT",-10,10)
end

function f:OnEvent(self,event,name)
	if name ~= addon then return end
	print("Addon "..addon.." loaded")
	f:RegisterFonts()
	HzFontPack1DB = HzFontPack1DB or {}
	f.panel = f.sol.AddOptionsPanel(addon, function(self) f:Options(self, anchor) end)
	f.sol.AddSlashCommand(addon,"/hz","/hzfp1","/hzfontpack1")
	self:UnregisterEvent("ADDON_LOADED")
end

f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self,event,...) f:OnEvent(self,event,...) end)
